#!/bin/sh

P_LOCAL=${PPP_LOCAL}
P_REMOTE=${PPP_REMOTE}
P_IFACE=${PPP_IFACE}

hook_unnumbered() {
	local cfg="$1"
	local proto ifname unnumbered

	config_get proto "$cfg" proto
	[ "$proto" = "pppoe" ] || return 0

	config_get ifname "$cfg" ifname
	[ "x$P_IFACE" = "x$ifname" ] || return 0

	config_get unnumbered "$cfg" unnumbered
	[ -n "$unnumbered" ] || return 0

	# Get ipaddr and netmask from unnumbered interface.
	# And that interface must be static one.
	local proto ipaddr netmask
	config_get proto "$unnumbered" proto
	config_get ipaddr "$unnumbered" ipaddr
	config_get netmask "$unnumbered" netmask
	[ -n "$ipaddr" -a -n "$netmask" -a "x$proto" = "xstatic" ] || return 0

	eval "$(ipcalc.sh $ipaddr $netmask)"

	# Validate netowrk address
	if [ "x$P_LOCAL" = "x$NETWORK" ]; then
		/sbin/ifconfig ${P_IFACE} "$ipaddr" pointopoint ${P_REMOTE}
		/sbin/route add default gw ${P_REMOTE}
	fi
}

. /etc/functions.sh
include /lib/network
scan_interfaces
config_load network

config_foreach hook_unnumbered interface

